/*===================================================================================================
                    Copyright(c) 2011 Siemens PLM Software Corp. All rights reserved.
                             Unpublished - All rights reserved
====================================================================================================
File description:
    
    Filename : epm_register_handler.c

    This file registers functions which are called when Teamcenter is being initialized

====================================================================================================
Date               Name                  Description of Change
2011-8-21			Ray wei              creation

$HISTORY$
==================================================================================================*/

#pragma warning (disable: 4819) 

/**
* @headerfile			tcua ͷļ
*/
#include <server_exits/user_server_exits.h>
#include <tccore/custom.h>
#include <epm/epm.h>

/**
* @headerfile			standard c & cpp header files
*/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <time.h>


/**
* @headerfile			user's header files
*/
#include "epm_register_handler.h"
#include "epm_handler_common.h"



// Method and Workflow Handler
extern DLLAPI int CUST_init_module(int *decision, va_list args)
{
	int ifail = ITK_ok, n=0;
	char date_buf[80],*expire_date;
	time_t now;
	struct   tm   *p;

	*decision = ALL_CUSTOMIZATIONS;

	
	//ifail = EPM_register_action_handler("qtmc-sign-ir", "qtmc-sign-ir", 
	//(EPM_action_handler_t)qtmc_sign_ir); 
	//if(ifail == ITK_ok) 
	//{ 
	//	fprintf(stdout,"Registering action handler qtmc-sign-ir completed!\n"); 
	//} 
	//else
	//{
	//	fprintf(stdout , "Registering action handler qtmc-sign-ir failed %d!\n",ifail);
	//}

	ifail=EPM_register_action_handler("kl_erp_save", "kl_erp_save", kl_erp_save);

	if(ifail)
	{
		printf("register save error");
	}else
	{
		printf("register save ok");

	}
	ifail = EPM_register_action_handler("kl_erp_bom", "kl_erp_bom", kl_erp_bom);
	if (ifail)
	{
		printf("register bom error");
	}
	else
	{
		printf("register bom ok");

	}
	// ifail=EPM_register_action_handler("kl_erp_update", "kl_erp_update", kl_erp_update);
	// if (ifail)
	// {
	// 	printf("register update error");
	// }
	// else
	// {
	// 	printf("register update ok");
	//
	// }
	
	return ifail;
}
//
////register service method
extern DLLAPI int USERSERVICE_custom_register_methods()
{
	
	////2.7 SP-CUS-007 DBOMEBOM
	//numberOfArguments = 1;
	//functionPtr = Q7_ebom_to_pbom;
	//argumentList = (int*)MEM_alloc(numberOfArguments * sizeof(int) );
	//argumentList[0] = USERARG_TAG_TYPE;
	////argumentList[1] = USERARG_STRING_TYPE + USERARG_ARRAY_TYPE;
	//returnValueType = USERARG_STRING_TYPE;
	//ITKCALL(status = USERSERVICE_register_method("Q7_ebom_to_pbom", functionPtr, numberOfArguments,
	//	argumentList, returnValueType ));
	//MEM_free(argumentList);
	//if(status == ITK_ok)
	//{
	//	fprintf( stdout, "\n Registering Q7_ebom_to_pbom finished\n" );
	//}
	//else
	//{
	//	fprintf( stdout, "\n Registering Q7_ebom_to_pbom failed %d\n" , status );
	//}
	////QTM_ebom_to_pbom
	//numberOfArguments = 1;
	//functionPtr = QTM_ebom_to_pbom;
	//argumentList = (int*)MEM_alloc(numberOfArguments * sizeof(int) );
	//argumentList[0] = USERARG_TAG_TYPE;
	////argumentList[1] = USERARG_STRING_TYPE + USERARG_ARRAY_TYPE;
	//returnValueType = USERARG_STRING_TYPE;
	//ITKCALL(status = USERSERVICE_register_method("QTM_ebom_to_pbom", functionPtr, numberOfArguments,
	//	argumentList, returnValueType ));
	//MEM_free(argumentList);
	//if(status == ITK_ok)
	//{
	//	fprintf( stdout, "\n Registering QTM_ebom_to_pbom finished\n" );
	//}
	//else
	//{
	//	fprintf( stdout, "\n Registering QTM_ebom_to_pbom failed %d\n" , status );
	//}
	////QTM_ebom_to_mbom
	//numberOfArguments = 1;
	//functionPtr = QTM_ebom_to_mbom;
	//argumentList = (int*)MEM_alloc(numberOfArguments * sizeof(int) );
	//argumentList[0] = USERARG_TAG_TYPE;
	////argumentList[1] = USERARG_STRING_TYPE + USERARG_ARRAY_TYPE;
	//returnValueType = USERARG_STRING_TYPE;
	//ITKCALL(status = USERSERVICE_register_method("QTM_ebom_to_mbom", functionPtr, numberOfArguments,
	//	argumentList, returnValueType ));
	//MEM_free(argumentList);
	//if(status == ITK_ok)
	//{
	//	fprintf( stdout, "\n Registering QTM_ebom_to_mbom finished\n" );
	//}
	//else
	//{
	//	fprintf( stdout, "\n Registering QTM_ebom_to_mbom failed %d\n" , status );
	//}

	////2.6 SP-CUS-006е¶excelϢ
	//numberOfArguments = 3;
	//functionPtr = qtmc_update_revision_prop;
	//argumentList = (int*)MEM_alloc(numberOfArguments * sizeof(int) );
	//argumentList[0] = USERARG_TAG_TYPE+USERARG_ARRAY_TYPE;
	//argumentList[1] = USERARG_TAG_TYPE;
	//argumentList[2] = USERARG_STRING_TYPE;
	//returnValueType = USERARG_VOID_TYPE;
	//ITKCALL(status = USERSERVICE_register_method("QTMC_update_revision_prop",functionPtr,numberOfArguments,argumentList,returnValueType));
	//if(status == ITK_ok)
	//{
	//	fprintf(stdout,"Registering user service QTMC_update_revision_prop successful !\n");
	//}else{
	//	fprintf(stdout,"Registering user service QTMC_update_revision_prop failed %d\n",status);
	//}

	//

	////SP-CUS-017SolidWorksģ浽TC
	//numberOfArguments = 7;
	//functionPtr = qtmc_import_solidworks_to_tc;
	//argumentList = (int*)MEM_alloc(numberOfArguments * sizeof(int) );
	//argumentList[0] = USERARG_STRING_TYPE;
	//argumentList[1] = USERARG_STRING_TYPE;
	//argumentList[2] = USERARG_STRING_TYPE;
	//argumentList[3] = USERARG_TAG_TYPE;
	//argumentList[4] = USERARG_LOGICAL_TYPE;
	//argumentList[5] = USERARG_LOGICAL_TYPE;
	//argumentList[6] = USERARG_LOGICAL_TYPE;
	//returnValueType = USERARG_LOGICAL_TYPE;
	//ITKCALL(status = USERSERVICE_register_method("QTMC_import_solidworks",functionPtr,numberOfArguments,argumentList,returnValueType));
	//if(status == ITK_ok)
	//{
	//	fprintf(stdout,"Registering user service QTMC_import_solidworks successful !\n");
	//}else{
	//	fprintf(stdout,"Registering user service QTMC_import_solidworks failed %d\n",status);
	//}


	////3.8 SP-CUS-020ϵм
	//numberOfArguments = 3;
	//functionPtr = qtmc_update_series_parts;
	//argumentList = (int*)MEM_alloc(numberOfArguments * sizeof(int) );
	//argumentList[0] = USERARG_TAG_TYPE;
	//argumentList[1] = USERARG_STRING_TYPE;
	//argumentList[2] = USERARG_STRING_TYPE;
	//returnValueType = USERARG_TAG_TYPE;
	//ITKCALL(status = USERSERVICE_register_method("QTMC_update_series_parts",functionPtr,numberOfArguments,argumentList,returnValueType));
	//if(status == ITK_ok)
	//{
	//	fprintf(stdout,"Registering user service QTMC_update_series_parts successful !\n");
	//}else{
	//	fprintf(stdout,"Registering user service QTMC_update_series_parts failed %d\n",status);
	//}

	//numberOfArguments = 1;
	//functionPtr = qtmc_by_pass;
	//argumentList = (int*)MEM_alloc(numberOfArguments * sizeof(int) );
	//argumentList[0] = USERARG_LOGICAL_TYPE;
	//returnValueType = USERARG_VOID_TYPE;
	//ITKCALL(status = USERSERVICE_register_method("QTMC-bypass",functionPtr,numberOfArguments,argumentList,returnValueType));
	//if(status == ITK_ok)
	//{
	//	fprintf(stdout,"Registering user service QTMC-bypass successful !\n");
	//}else{
	//	fprintf(stdout,"Registering user service QTMC-bypass failed %d\n",status);
	//}


	//numberOfArguments = 3;
	//functionPtr = qtmc_qry_service;
	//argumentList = (int*)MEM_alloc(numberOfArguments * sizeof(int) );
	//argumentList[0] = USERARG_STRING_TYPE;
	//argumentList[1] = USERARG_STRING_TYPE+USERARG_ARRAY_TYPE;
	//argumentList[2] = USERARG_STRING_TYPE+USERARG_ARRAY_TYPE;
	//returnValueType = USERARG_TAG_TYPE+USERARG_ARRAY_TYPE;
	//ITKCALL(status = USERSERVICE_register_method("QTMC_Search",functionPtr,numberOfArguments,argumentList,returnValueType));
	//if(status == ITK_ok)
	//{
	//	fprintf(stdout,"Registering user service QTMC_Search successful !\n");
	//}else{
	//	fprintf(stdout,"Registering user service QTMC_Search failed %d\n",status);
	//}


	//
	////7.3	HBOMݵĵ
	//numberOfArguments = 4;
	//functionPtr = qtmc_update_hbom_bomline_prop;
	//argumentList = (int*)MEM_alloc(numberOfArguments * sizeof(int) );
	//argumentList[0] = USERARG_TAG_TYPE;
	//argumentList[1] = USERARG_TAG_TYPE;
	//argumentList[2] = USERARG_STRING_TYPE;
	//argumentList[3] = USERARG_STRING_TYPE;
	//returnValueType = USERARG_VOID_TYPE;
	//ITKCALL(status = USERSERVICE_register_method("QTMC_update_bomline",functionPtr,numberOfArguments,argumentList,returnValueType));
	//if(status == ITK_ok)
	//{
	//	fprintf(stdout,"Registering user service QTMC_update_bomline successful !\n");
	//}else{
	//	fprintf(stdout,"Registering user service QTMC_update_bomline failed %d\n",status);
	//}

	return 0;
}

